/** 
 *  An example URI and its component parts. [rfc3986] 
 *  
 *  foo://example.com:8042/over/there?name=ferret#nose 
 *  \_/   \______________/\_________/ \_________/ \__/ 
 *   |           |            |            |        | 
 * scheme     authority       path        query   fragment 
 *
 * The pattern is
 * <scheme> : <authority> / <path> ? <query> # <fragment>
 */ 
 
public class CustomURIValidator { 
    String scheme, authority, path, query, fragment; 
 
    public CustomURIValidator(String uri) throws ...  { 
        ... 
        validateScheme(); 
        validateAuthority(); 
        validatePath(); 
    } 
    /** @return true if c is either ALPHA, DIGIT, '-', '.', '_' or '~' **/ 
    public static boolean isUnreservedCharacter(char c) { ... } 
     
    private void validateAuthority() throws EmptyComponentException, 
                                                  ComponentTooLongException { 
        if (authority == null || authority.length() < 1) 
            throw new EmptyComponentException("authority"); 
        if (authority.length() > 255) 
            throw new ComponentTooLongException("authority",255); 
    } 
     
    private void validatePath() throws ComponentTooLongException,
                                                  IllegalCharacterException {
        //leave blank
    } 
     
    private void validateScheme() throws ... { ... }
} 
